<!DOCTYPE html>
<html lang="en">

<head>
    <title>document</title>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.0/dist/css/bootstrap.min.css">
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.0/dist/js/bootstrap.min.js"></script>
    <!-- Import style bootstrap cho datatable -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.13.3/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.13.3/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.13.3/js/dataTables.bootstrap4.min.js"></script>
</head>

<body>
    <div class="container-fluid">
        <h1 class="text-center">Danh sách người dùng đăng kí </h1>
        <div class="row">
            <div class="col mb-4 mt-4">
                <button class="btn btn-success">Thêm Uesr</button>
            </div>
        </div>
        <div class="row">
            <div class="col">
                <table id="user-table" class="table table-striped table-hover table-bordered">
                    <thead>
                        <tr>
                            <th>ID</th>
                            <th>first name </th>
                            <th>last name</th>
                            <th>country</th>
                            <th>subject</th>
                            <th>customer Type</th>
                            <th>register Status</th>
                            <th>action</th>
                        </tr>
                    </thead>
                    <tbody>

                    </tbody>
                </table>
            </div>
        </div>

    </div>

</body>
<script>
    "use strict"

    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_STATUS_DELETE_OK = 204;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gREQUEST_STATUS_CREATE_OK = 201;
    const gBASE_URL = "http://203.171.20.210:8080/crud-api/users/";

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    $(document).ready(function () {
        onPageLoading();
        // khai báo nút sửa 
        $("#user-table").on("click", ".btn-edits", onSuaClick);
        $("#user-table").on("click", ".btn-deletes", onXoaClick);
    });
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {
        "use strict"
        console.log("đã load xong thẻ body ");
        // load data table jquery nhưng chưa truyền dữ liệu 
        khoiTaoDataTable();
        //b1 bỏ qua
        //b2 bỏ qua
        //b3  call api && //b4 load data in table 
        callApiAllUser();
    }
    // khai báo sự kiện nút sửa 
    function onSuaClick(){
        console.log("ấn nút sửa ");
        var vObject = readObjectRow(this);
        console.log("id là:  "  + vObject.id);
    }
    // khai báo sự kiện nút sửa 
    function onXoaClick(){
        console.log("ấn nut xóa ");
        var vObject = readObjectRow(this);
        console.log("id là:  "  + vObject.id); 
        
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // khởi tạo data table 
    function khoiTaoDataTable(){
         /* add JSON data vào DataTable sử dụng add trực tiếp DataTable row */
         $("#user-table").DataTable({
          columns: [
            { data: "id" },
            { data: "firstname" },
            { data: "lastname" },
            { data: "country" },
            { data: "subject" },
            { data: "customerType" },
            { data: "registerStatus" },
            { data: "action" }

          ],
          columnDefs: [
          {
            targets: 0,   // cột id
            className: "text-center text-primary"
          },
          {
            targets: 3, // cột age
            className: "text-right"
          },
          {
            targets: 7,
            defaultContent: "<button class='btn btn-primary mr-2 btn-edits'>Sửa</button>" +
            "<button class='btn btn-danger btn-deletes'>Xóa</button>",
          },
          ]
        });
    }
    //  gọi API load all users
    function callApiAllUser() {
        // khai báo ajax jquery
        $.ajax({
            url: gBASE_URL,
            type: "GET",
            dataType: "json",
            success: function (paramRes) {
                // khi gọi api call all user thành công 
                //b4 load data in table 
                getInsertRowTable(paramRes);
            },
            error: function (paramError) {
                console.log("lỗi khi gọi api All user" + paramError.status);
            }
        });
    }
    // hàm thêm từng dòng dữ liệu vào
    function getInsertRowTable(paramRes) {
        var vTable = $("#user-table").DataTable();
        vTable.clear();// xóa trắng tbody trước khi load dữ liệu 
        vTable.rows.add(paramRes);
        vTable.draw();
      }

    // lấy tất cả giá trị của 1 hàng tương ứng với nút bấm trên hàng đó 
    function   readObjectRow(paramThis){
        console.log(paramThis);
        var vRowClick = $(paramThis).closest("tr"); // xác định hàng của nút ấn trên table  nut ấn 
        var vTable = $("#user-table").DataTable();   // tạo biến đến dataTable 
        var vDataRow = vTable.row(vRowClick);  // tìm hàng này trên data table trên data table 
        return vDataRow.data();
    }
   

   
</script>

</html>